<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;

class SyncerrorModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "sync_error";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "syncerror";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "table_name", "params", "data", "aplikasi", "date_created"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id"            => "syncerror.id",
        "table_name"    => "syncerror.table_name",
        "params"        => "syncerror.params",
        "data"          => "syncerror.data",
        "aplikasi"      => "syncerror.aplikasi",
        "date_created"  => "syncerror.date_created"

    ];

    public function saveError($table_name, $paramsString, $data, $aplikasi)
    {
        $errExist = (new SyncerrorModel())->getQuery()->where("syncerror.table_name", "=", $table_name)
            ->where("syncerror.params", "LIKE", $paramsString)
           ->where("syncerror.aplikasi", "=", $aplikasi)
            ->first();
        if (! $errExist) {
            $model = new SyncerrorModel();
            $model->table_name = $table_name;
            $model->params = $paramsString;
            $model->data = $data;
            $model->aplikasi = $aplikasi;
            $model->date_created = Carbon::now()->toDateTimeString();
            $model->save();
        }

    }

    public static function deleteError($ID) {
        SyncerrorModel::find($ID)->delete();
    }

    public function syncFromOracleHO($fromCMS = false)
    {
        echo "start sync Sync Error from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Sync Errors", Carbon::now()->toDateTimeString(), "", "start");

        $modelExist = new self();
        $syncErrors = $modelExist->getQuery()   ->select(["id", "table_name", "params"])
            ->where("syncerror.aplikasi", "=", "HO")
            ->get();

        foreach($syncErrors as $syncError) {
            echo "started table: " . $syncError->table_name, PHP_EOL;
            $params = json_decode( $syncError->params, true);
            $paramAND = [];
            foreach($params as $key => $value) {
                $paramAND[] = $key . " = " . $value;
            }
            $strParam[] = " ( " . implode(" AND ", $paramAND) . " ) ";
            switch ($syncError->table_name){
                case "pelni_scm_io_v"       :
                    $success = (new KapalModel)->syncErrorFromOracleHO($params["MTL_IO_CODE"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
                case "pelni_scm_items_v"    :
                    $success = (new ItemModel)->syncErrorFromOracleHO($params["INVENTORY_ITEM_ID"], $params["ORGANIZATION_ID"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
                case "pelni_voyage_v"       :
                    $success = (new VoyageModel)->syncErrorFromOracleHO($params["VOYAGE_ID"], $params["ORGANIZATION_ID"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
                case "pelni_scm_subinv_v"   :
                    $success = (new LokasiitemModel)->syncErrorFromOracleHO($params["SUBINV_CODE"], $params["MTL_IO_ID"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
                case "pelni_scm_pr_to_po_v" :
                    $success = (new PopenerimaanModel)->syncErrorFromOracleHO($params["PO_NUMBER"], $params["IO"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
                case "pelni_iot_v"          :
                    $success = (new PopenerimaanioModel)->syncErrorFromOracleHO($params["SHIPMENT_NUMBER"], $params["TO_ORG_ID"], $params["FROM_ORG_ID"], $fromCMS);
                    if($success) { SyncerrorModel::deleteError($syncError->id); }
                    break;
            }
//            } END OF WHICH
            echo "end of running data from oracle" , PHP_EOL;
        }

        (new LogsyncoracleModel)->setLogSync("Sync Errors", Carbon::now()->toDateTimeString(), "", "success");
    }

    public static function syncFromHOKapal($fromCMS = false)
    {
        $syncHandler = new \App\Http\Handler\CurlHandler();
        $syncErrors = (new SyncerrorModel())->getQuery()->where("aplikasi", "=", "KAPAL")->get();
        (new LogsynckapalModel)->setLogSync("Sync Errors HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        foreach($syncErrors as $syncError) {
            $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/";
            $params = json_decode( $syncError->params, true);
            $paramAND = [];
            foreach($params as $key => $value) {
                $paramAND[] = $key . "=" . $value;
            }

            $return = false;
            switch($syncError->table_name) {
                case "popenerimaan" :   $url .= "sync_error_po?" . implode("&", $paramAND);
                                        try {
                                            $response = $syncHandler->setUrl($url)->send();
                                            $res = json_decode($response, false);
                                            if (! empty($res->data)){
                                                foreach ($res->data as $item) {
                                                    echo " data " . $item->poNumber, PHP_EOL;
                                                    $return = \App\Http\Models\PopenerimaanModel::storeFromHO($item, $fromCMS);
                                                    if($return) { SyncerrorModel::deleteError($syncError->id); echo "Delete ID : " . $syncError->id, PHP_EOL; }
                                                }
                                            }
                                        } catch (Exception $e) {
                                            echo $e->getMessage();
                                            (new LogsynckapalModel)->setLogSync("Sync Errors PO Penerimaan HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                                        }
                                        break;
                case "popenerimaanio" : $url .= "sync_error_po_io?" . implode("&", $paramAND);
                                        try {
                                            $response = $syncHandler->setUrl($url)->send();
                                            $res = json_decode($response, false);
                                            if (!empty($res->data)){
                                                foreach ($res->data as $item) {
                                                    echo " data " . $item->ioNumber, PHP_EOL;
                                                    $return = \App\Http\Models\PopenerimaanioModel::storeFromHO($item, $fromCMS);
                                                    if($return) { SyncerrorModel::deleteError($syncError->id); echo "Delete ID : " . $syncError->id, PHP_EOL; }
                                                }
                                            }
                                        } catch (Exception $e) {
                                            echo $e->getMessage();
                                            (new LogsynckapalModel)->setLogSync("Sync Errors Penerimaan IO HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                                        }
                                        break;

                case "voyages" : $url .= "sync_error_voyages?" . implode("&", $paramAND);
                                        try {
                                            $response = $syncHandler->setUrl($url)->send();
                                            $res = json_decode($response, false);
                                            if (!empty($res->data)){
                                                foreach ($res->data as $item) {
                                                    echo " data " . $item->voyageKode, PHP_EOL;
                                                    $return = \App\Http\Models\VoyageModel::storeFromHO($item, $fromCMS);
                                                    if($return) { SyncerrorModel::deleteError($syncError->id); echo "Delete ID : " . $syncError->id, PHP_EOL; }
                                                }
                                            }
                                        } catch (Exception $e) {
                                            echo $e->getMessage();
                                            (new LogsynckapalModel)->setLogSync("Sync Errors Voyage HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                                        }
                                        break;

                case "item" : echo $url .= "sync_error_item?" . implode("&", $paramAND);
                                        try {
                                            $response = $syncHandler->setUrl($url)->send();
                                            $res = json_decode($response, false);
                                            if (!empty($res->data)){
                                                $i = 1;
                                                foreach ($res->data as $item) {
                                                    echo $i++ . " data " . $item->namaItem, PHP_EOL;
                                                    $return = \App\Http\Models\ItemModel::storeFromHO($item, $fromCMS);
                                                    if($return) { SyncerrorModel::deleteError($syncError->id); echo "Delete ID : " . $syncError->id, PHP_EOL; }
                                                }
                                            }
                                        } catch (Exception $e) {
                                            echo $e->getMessage();
                                            (new LogsynckapalModel)->setLogSync("Sync Errors Item HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                                        }
                                        break;
            };
        }
        (new LogsynckapalModel)->setLogSync("Sync Errors HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }

    /* public function syncFromHOKapal()
    {
        echo "start sync Sync Error from HO", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Sync Error", Carbon::now()->toDateTimeString(), "", "start");

        $modelExist = new self();
        $syncErrors = $modelExist->getQuery()   ->select(["id", "table_name", "params"])
            ->where("syncerror.aplikasi", "=", "KAPAL")
            ->get();

        foreach($syncErrors as $syncError) {
            echo "started table: " . $syncError->table_name, PHP_EOL;
            $params = json_decode("[" . $syncError->params . "]", true);
            $paramAND = [];
            foreach($params as $key => $value) {
                $paramAND[] = $key . " = " . $value;
            }
            $strParam[] = " ( " . implode(" AND ", $paramAND) . " ) ";

            switch ($syncError->table_name){
                case "pelni_scm_io_v"       :   try {
                    (new KapalModel)->storingDataFromOracle($params);
                    SyncerrorModel::deleteError($syncError->id);
                } catch (\Exception $e) { } break;
            }
//            } END OF WHICH
            echo "end of running data from oracle" , PHP_EOL;
        }

        (new LogsyncoracleModel)->setLogSync("Sync Error", Carbon::now()->toDateTimeString(), "", "success");
    } */
}
